---
title: "Setting ‘Google Trends Explore’ Tasks"
url: "https://docs.dataforseo.com/v3/keywords_data/google_trends/explore/task_post/"
date: "2026-08-28"
---

## Setting ‘Google Trends Explore’ Tasks

  
This endpoint will provide you with the keyword popularity data from the ‘Explore’ feature of Google Trends. You can check keyword trends for Google Search, Google News, Google Images, Google Shopping, and YouTube.

This is the Standard method of data retrieval. If you don’t need to receive data in real-time, this method is the best option for you. Set a task and retrieve the results when our system collects them. Execution time depends on the system workload.

**Note:** Due to the limited capacity of the Google Trends service and related restrictions, our system is restricted to the total of 500K daily requests across all Google Trends API endpoints and all users. We recommend that you distribute your requests over several days to avoid data collection errors and ensure stable access to Google Trends data. Learn more on our [Help Center](https://dataforseo.com/help-center/google-trends-api-limits-and-restrictions).

If your system requires delivering instant results, [the Live method](https://docs.dataforseo.com/v3/keywords_data/google_trends/explore/live.md) will be a better solution. This method doesn’t require making separate POST and GET requests to the corresponding endpoints.

Historical data for the `web` type: available from `2004-01-01`;  
Historical data for other types: available from `2008-01-01`.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/keywords\_data/google\_trends/explore/task\_post     

      

Pricing

  Your account will be charged only for setting a task.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/keywords-data/google-trends "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). Task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the `40006` error. Visit [DataForSEO Help Center](https://dataforseo.com/help-center/best-practices-for-handling-keywords-data-api-requests) to get practical tips for request handling depending on your Keyword Data API payload volume.

You will get information for every single keyword in an array.

You can send up to 5 keywords in one `keywords` array. Our system will charge your account per request, no matter what number of keywords an array has, the price for 1 or 5 keywords will be the same.

You can also retrieve the results of completed tasks using the unique task identifier `id`. Alternatively, we can send them to you as soon as they are ready if you specify the `postback_url` or `pingback_url` when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the [tasks\_ready](https://docs.dataforseo.com/v3/keywords_data/google_trends/explore/tasks_ready.md) list. The error code and message depend on your server’s configuration.

See [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) to learn more about using pingbacks and postbacks with DataForSEO APIs.

Below you will find a detailed description of the fields you can use for setting a task.

**Description of the fields for setting a task:**

| Field name | Type | Description |
|---|---|---|
| `keywords` | array | *keywords*   **required field**   the maximum number of keywords you can specify: 5   the maximum number of characters you can specify in a keyword: 100   the minimum number of characters must be greater than 1   comma characters (`,`) in the specified keywords will be unset and ignored  **Note:** keywords cannot consist of a combination of the following characters: `< > \|  " - + = ~ ! : * ( ) [ ] { }`  **Note:** to obtain `google_trends_topics_list` and `google_trends_queries_list` items, specify no more than 1 keyword  learn more about rules and limitations of `keyword` and `keywords` fields in DataForSEO APIs in this [Help Center article](https://dataforseo.com/help-center/rules-and-limitations-of-keyword-and-keywords-fields-in-dataforseo-apis) |
| `location_name` | string | *full name of search engine location*   optional field   if you don't use this field, you will recieve global results   **if you use this field, you don't need to specify `location_code`**   you can use this field as an array to set several locations, each corresponding to a specific keyword - [learn more](https://dataforseo.com/help-center/multiple-locations-in-google-trends-api);   you can receive the list of available locations of the search engine with their `location_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_trends/locations`   example:   `United Kingdom` |
| `location_code` | integer | *search engine location code*   optional field   if you don't use this field, you will recieve global results   **if you use this field, you don't need to specify `location_name`**   you can use this field as an array to set several locations, each corresponding to a specific keyword - [learn more](https://dataforseo.com/help-center/multiple-locations-in-google-trends-api);   you can receive the list of available locations of the search engines with their `location_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_trends/locations`   example:   `2840` |
| `language_name` | string | *full name of search engine language*   optional field   default value: `English`   if you use this field, you don't need to specify `language_code`   you can receive the list of available languages of the search engine with their `language_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_trends/languages`   example:   `English` |
| `language_code` | string | *search engine language code*   optional field   default value: `en`   if you use this field, you don't need to specify `language_name`   you can receive the list of available languages of the search engine with their `language_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_trends/languages`   example:   `en` |
| `type` | string | *google trends type*   optional field   if you don't specify this field, the `web` type will be used by default   possible values: `web`, `news`, `youtube`, `images`, `froogle` |
| `category_code` | integer | *google trends search category*   optional field   if you don't specify this field, the `0` value will be applied by default and the search will be carried out across all available categories   you can receive the list of available categories with their `category_code` by making a separate request to the `https://api.dataforseo.com/v3/keywords_data/google_trends/categories` |
| `date_from` | string | *starting date of the time range*   optional field   if you don't specify this field, the current day and month of the preceding year will be used by default   minimal value for the `web` type: `2004-01-01`   minimal value for other types: `2008-01-01`   date format: `"yyyy-mm-dd"`   example:   `"2019-01-15"` |
| `date_to` | string | *ending date of the time range*   optional field   if you don't specify this field, the today's date will be used by default   date format: `"yyyy-mm-dd"`   example:   `"2019-01-15"` |
| `time_range` | string | *preset time ranges*   optional field   if you specify `date_from` or `date_to` parameters, this field will be ignored when setting a task   *possible values for all `type` parameters:*   `past_hour`, `past_4_hours`, `past_day`, `past_7_days`, `past_30_days`, `past_90_days`, `past_12_months`, `past_5_years`   *possible values for `web` only:*   `2004_present`   *possible values for `news`, `youtube`, `images`, `froogle`:*   `2008_present` |
| `item_types` | array | *types of items returned*   optional field   to speed up the execution of the request, specify one item at a time;   possible values:   `"google_trends_graph"`, `"google_trends_map"`, `"google_trends_topics_list"`,`"google_trends_queries_list"`   default value:   `"google_trends_graph"`  **Note:** to obtain `google_trends_topics_list` and `google_trends_queries_list` items, specify no more than 1 keyword in the `keywords` field |
| `postback_url` | string | *URL for sending task results*   optional field   once the task is completed, we will send a POST request with its results compressed in the `gzip` format to the `postback_url` you specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request.   example:   `http://your-server.com/postbackscript?id=$id`   `http://your-server.com/postbackscript?id=$id&tag=$tag`   **Note:** special characters in `postback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`  learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `pingback_url` | string | *notification URL of a completed task*   optional field   when a task is completed we will notify you by GET request sent to the URL you have specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request   example:   `http://your-server.com/pingscript?id=$id`   `http://your-server.com/pingscript?id=$id&tag=$tag`   **Note:** special characters in `pingback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`  learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` object of the response |



  
 As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks.

**Description of the fields in the results array:**

| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total tasks cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`**array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *unique task identifier in our system*   **unique task identifier in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*    generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of response codes [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| `result` | array | *array of results*   in this case, the value will be `null` |







  
 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/google_trends/explore/task_post" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "date_from": "2019-01-01",
        "date_to": "2020-01-01",
        "type": "youtube",
        "category_code": 3,
        "keywords": [
            "seo api",
            "rank api"
        ]
    }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_name" => "United States",
	"date_from" => "2019-01-01",
	"date_to" => "2020-01-01",
	"keywords" => array(
		"seo api"
	)
);
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
	"location_name" => "United States",
	"date_from" => "2019-01-01",
	"date_to" => "2020-01-01",
	"type" => "youtube",
	"category_code" => 3,
	"keywords" => array(
		"seo api",
		"rank api"
	),
	"tag" => "some_string_123",
	"pingback_url" => 'https://your-server.com/pingscript?id=$id&tag=$tag'
);
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
	"location_name" => "United States",
	"date_from" => "2019-01-01",
	"date_to" => "2020-01-01",
	"type" => "youtube",
	"category_code" => 3,
	"keywords" => array(
		"seo api",
		"rank api"
	),
	"postback_url" => "https://your-server.com/postbackscript"
);
try {
	// POST /v3/keywords_data/google_trends/explore/task_post
	$result = $client->post('/v3/keywords_data/google_trends/explore/task_post', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
```





```js
const post_array = [];

post_array.push({
  "location_name": "United States",
  "date_from": "2019-01-01",
  "date_to": "2020-01-01",
  "type": "youtube",
  "category_code": 3,
  "keywords": ["seo api", "rank api"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/google_trends/explore/task_post',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
```





```python
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    date_from="2019-01-01",
    date_to="2020-01-01",
    keywords=[
        "seo api"
    ]
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $post_id, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    location_name="United States",
    date_from="2019-01-01",
    date_to="2020-01-01",
    type="youtube",
    category_code=3,
    keywords=[
        "seo api",
        "rank api"
    ],
    tag="some_string_123",
    pingback_url="https://your-server.com/pingscript?id=$id&post_id=$post_id"
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $post_id, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    location_name="United States",
    date_from="2019-01-01",
    date_to="2020-01-01",
    type="youtube",
    category_code=3,
    keywords=[
        "seo api",
        "rank api"
    ],
    postback_url="https://your-server.com/postbackscript"
)
# POST /v3/keywords_data/google_trends/explore/task_post
response = client.post("/v3/keywords_data/google_trends/explore/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
```





```csharp
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_trends_task_post()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to set a task
            postData.Add(new
            {
                location_name = "United States",
                date_from = "2019-01-01",
                date_to = "2020-01-01",
                keywords = new[]
                {
                    "seo api"
                }
            });
            // after a task is completed, we will send a GET request to the address you specify
            // instead of $id and $tag, you will receive actual values that are relevant to this task
            postData.Add(new
            {
                location_name = "United States",
                date_from = "2019-01-01",
                date_to = "2020-01-01",
                type = "youtube",
                category_code = 3,
                keywords = new[]
                {
                    "seo api",
                    "rank api"
                },
                tag = "some_string_123",
                pingback_url = "https://your-server.com/pingscript?id=$id&tag=$tag"
            });
            // after a task is completed, we will send a GET request to the address you specify
            // instead of $id and $tag you will receive actual values that are relevant to this task
            postData.Add(new
            {
                location_name = "United States",
                date_from = "2019-01-01",
                date_to = "2020-01-01",
                type = "youtube",
                category_code = 3,
                keywords = new[]
                {
                    "seo api",
                    "rank api"
                },
                tag = "some_string_123",
                postback_url = "https://your-server.com/postbackscript"
            });
            // POST /v3/keywords_data/google_trends/explore/task_post
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/google_trends/explore/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20200130",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.0882 sec.",
  "cost": 0.15,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "02122119-1535-0170-0000-0228cf083d8e",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0017 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
         "google_trends",
         "explore",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "explore",
        "se": "google_trends",
        "location_name": "United States",
        "type": "youtube",
        "date_from": "2019-01-15",
        "date_to": "2020-01-01",
        "category_code": 3,
        "keywords": [
          "seo api",
          "rank api"
        ]
      },
      "result": null
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp